from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, Int, String

Stringmlst_Py_V0_1_0 = CommandToolBuilder(tool="stringMLST.py", base_command=["stringMLST.py"], inputs=[ToolInput(tag="in_build_db", input_type=Boolean(optional=True), prefix="--buildDB", doc=InputDocumentation(doc="Identifier for build db module")), ToolInput(tag="in_config", input_type=Boolean(optional=True), prefix="--config", doc=InputDocumentation(doc="= <configuration file>\nConfig file in the format described above.\nAll the files follow the structure followed by pubmlst. Refer extended document for details.")), ToolInput(tag="in_kmer_lengthkmer_size", input_type=Boolean(optional=True), prefix="-k", doc=InputDocumentation(doc="= <kmer length>\nKmer size for which the db has to be formed(Default k = 35). Note the tool works best with kmer length in between 35 and 66\nfor read lengths of 55 to 150 bp. Kmer size can be increased accordingly. It is advised to keep lower kmer sizes\nif the quality of reads is not very good.")), ToolInput(tag="in_prefix", input_type=Boolean(optional=True), prefix="--prefix", doc=InputDocumentation(doc="= <prefix>\nPrefix for db and log files to be created(Default = kmer). Also you can specify folder where you want the dbb to be created.")), ToolInput(tag="in_file_location_write", input_type=Boolean(optional=True), prefix="-a", doc=InputDocumentation(doc="File location to write build log")), ToolInput(tag="in_predict", input_type=Boolean(optional=True), prefix="--predict", doc=InputDocumentation(doc="Identifier for predict module")), ToolInput(tag="in_fast_q_one", input_type=Boolean(optional=True), prefix="--fastq1", doc=InputDocumentation(doc="= <fastq1_filename>\nPath to first fastq file for paired end sample and path to the fastq file for single end file.\nShould have extension fastq or fq.")), ToolInput(tag="in_fast_q_two", input_type=Boolean(optional=True), prefix="--fastq2", doc=InputDocumentation(doc="= <fastq2_filename>\nPath to second fastq file for paired end sample.\nShould have extension fastq or fq.")), ToolInput(tag="in_directory", input_type=Boolean(optional=True), prefix="--directory", doc=InputDocumentation(doc="= <directory>\nBATCH MODE : Location of all the samples for batch mode.")), ToolInput(tag="in_coverage", input_type=Boolean(optional=True), prefix="--coverage", doc=InputDocumentation(doc="Calculate sequence coverage for each allele. Turns on read generation (-r) and turns off fuzzy (-z 1)\nRequires bwa, bamtools and samtools be in your path")), ToolInput(tag="in_list", input_type=Boolean(optional=True), prefix="--list", doc=InputDocumentation(doc="= <list_file>\nLIST MODE : Location of list file and flag for list mode.\nlist file should have full file paths for all the samples/files.\nEach sample takes one line. For paired end samples the 2 files should be tab separated on single line.")), ToolInput(tag="in_output", input_type=File(optional=True), prefix="--output", doc=InputDocumentation(doc="= <output_filename>\nPrints the output to a file instead of stdout.")), ToolInput(tag="in_paired", input_type=Boolean(optional=True), prefix="--paired", doc=InputDocumentation(doc="Flag for specifying paired end files. Default option so would work the same if you do not specify for all modes.\nFor batch mode the paired end samples should be differentiated by 1/2.fastq or 1/2.fq")), ToolInput(tag="in_separate_reads_file", input_type=Boolean(optional=True), prefix="-r", doc=InputDocumentation(doc="A separate reads file is created which has all the reads covering all the locus.")), ToolInput(tag="in_single", input_type=Boolean(optional=True), prefix="--single", doc=InputDocumentation(doc="Flag for specifying single end files.")), ToolInput(tag="in_time_analysis_also", input_type=Boolean(optional=True), prefix="-t", doc=InputDocumentation(doc="Time for each analysis will also be reported.")), ToolInput(tag="in_prints_version_software", input_type=Boolean(optional=True), prefix="-v", doc=InputDocumentation(doc="Prints the version of the software.")), ToolInput(tag="in_overwrite", input_type=File(optional=True), prefix="--overwrite", doc=InputDocumentation(doc="By default stringMLST appends the results to the output_filename if same name is used.\nThis argument overwrites the previously specified output file.")), ToolInput(tag="in_fuzzy", input_type=Boolean(optional=True), prefix="--fuzzy", doc=InputDocumentation(doc="= <fuzzy threshold int>\nThreshold for reporting a fuzzy match (Default=300). For higher coverage reads this threshold should be set higher to avoid\nindicating fuzzy match when exact match was more likely. For lower coverage reads, threshold of <100 is recommended")), ToolInput(tag="in_get_mlst", input_type=Boolean(optional=True), prefix="--getMLST", doc=InputDocumentation(doc="Identifier for getMLST module")), ToolInput(tag="in_species", input_type=Boolean(optional=True), prefix="--species", doc=InputDocumentation(doc="= <species name>\nSpecies name from the pubMLST schemes (use '--species show' to get list of available schemes)\n'all' will download and build all")), ToolInput(tag="in_schemes", input_type=Boolean(optional=True), prefix="--schemes", doc=InputDocumentation(doc="Display the list of available schemes")), ToolInput(tag="in_locus_one", input_type=Int(), position=0, doc=InputDocumentation(doc="locusFile1")), ToolInput(tag="in_locus_two", input_type=Int(), position=1, doc=InputDocumentation(doc="locusFile2")), ToolInput(tag="in_profile", input_type=String(), position=0, doc=InputDocumentation(doc="profileFile"))], outputs=[ToolOutput(tag="out_output", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output", type_hint=File()), doc=OutputDocumentation(doc="= <output_filename>\nPrints the output to a file instead of stdout.")), ToolOutput(tag="out_overwrite", output_type=File(optional=True), selector=InputSelector(input_to_select="in_overwrite", type_hint=File()), doc=OutputDocumentation(doc="By default stringMLST appends the results to the output_filename if same name is used.\nThis argument overwrites the previously specified output file."))], container="quay.io/biocontainers/stringmlst:0.6.3--py_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Stringmlst_Py_V0_1_0().translate("wdl")

